;*********************************************************************
; MS2 Extra equates for asm   (C) 2006 James Murray
;*********************************************************************
;global vars used in asm
; $Id: ms2extrah.inc,v 1.40 2010/02/12 01:03:03 jsmcortina Exp $

.include "us_opt_asm.inc"

.globl pPTMpin, PTT, PTM, CRGFLG, PORTA, PORTB, PORTM, PORTT, PTAD

.globl next_txmode, txmode, txgoal, rcv_timeout, rd_wr, txcnt, txbuf, CANid, tbl_idx
.globl page, tables, ram_data
.globl vfy_fail, rd_wr, CANid, ibuf, next_txmode, stall_timeout, num_spk, coilsel, TC_ovflow, rotaryspksel, rotarydwlsel
.globl flagbyte2, lmms,FPdcounter,last_fsensdat, fc_counter
.globl lowres, lowres_ctr, tacho_targ
.globl spk_cutx, spk_cuty, spk_cuti
.globl log_offset
.globl WF, AWA, SOA
.globl  tcrank_done
.globl  tmpdwellsel

.equ MAX_CANBOARDS, 16
.equ NO_TBLES, 11
.equ SIZEOFTXBUF, 169  ; be sure to update ms2_extra.h as well
.equ flagbyte0_50ms,        0x01
.equ flagbyte0_complog,     0x20
.equ flagbyte0_tthlog,      0x40
.equ flagbyte0_trglog,      0x80

.equ flagbyte1_trig2active, 0x01
.equ flagbyte1_ovfclose,    0x04

.equ flagbyte2_twintrig,    0x01
.equ flagbyte2_twintrignow, 0x02
.equ flagbyte2_tc0stat,     0x10
.equ flagbyte2_runidle,     0x20
.equ flagbyte2_MV2,         0x80

.equ flagbyte3_kill_cat,    0x02
.equ flagbyte3_getcandat,   0x08
.equ flagbyte3_sndcandat,   0x10
.equ flagbyte3_runboost,    0x20
.equ flagbyte3_toothinit,   0x40
.equ flagbyte3_mapsample,   0x80

.equ flagbyte4_cantuning,   0x20
.equ flagbyte4_oddspk,      0x40

.equ FLAGBYTE5_CRK_DOUBLE, 0x01
.equ FLAGBYTE5_CRK_BOTH,   0x02
.equ FLAGBYTE5_CAM,        0x04
.equ FLAGBYTE5_CAM_DOUBLE, 0x08
.equ FLAGBYTE5_CAM_BOTH,   0x10
.equ FLAGBYTE5_CAM_NOISE,  0x20
.equ FLAGBYTE5_CAM_POLARITY, 0x40
.equ FLAGBYTE5_LOG_CLR,    0x80 

.equ FLAGBYTE6_DONEINIT,   0x01
.equ FLAGBYTE6_CRC,        0x08

.equ status1_needburn,      0x01
.equ status1_lostdata,      0x02
.equ status1_conferr,       0x04

.equ status3_donelog,      0x02

.equ OVFLO_SPK,             0x01
.equ OVFLO_DWL,             0x02
.equ OVFLO_ROT_SPK,         0x04
.equ OVFLO_ROT_DWL,         0x08

; ignition definitions to swap timer interrupts TC2/TC5 if MS2 vs. Microsquirt
.ifndef MICROSQUIRT
.set TC_ign,TC7     ; ***JB was TC2
.set TFLG_ign,0x80  ; ***JB was 0x04
.set TC_trig2,TC5
.set TFLG_trig2,0x20
.set TC_rotINJ3,TC2
.set TFLG_rotINJ3,0x04
.set TC_rotINJ4,TC4
.set TFLG_rotINJ4,0x10
.set TC_dwl,TC6
.set TFLG_dwl,0x40
.else
.set TC_ign,TC5
.set TFLG_ign,0x20
.set TC_trig2,TC2
.set TFLG_trig2,0x04
.set TC_rotINJ3,TC6
.set TFLG_rotINJ3,0x40
.set TC_rotINJ4,TC7
.set TFLG_rotINJ4,0x80
.set TC_dwl,TC4
.set TFLG_dwl,0x10
.endif

.equ COILABIT,0x1
.equ COILBBIT,0x2
.equ COILCBIT,0x4
.equ COILDBIT,0x8
.equ COILEBIT,0x10
.equ COILFBIT,0x20
.equ COILGBIT,0x40
.equ COILHBIT,0x80

.macro STACK_SOFT
;these are the minimum to stack
movw 0x3000, 2, -SP
movw 0x3002, 2, -SP
movw 0x3004, 2, -SP
.endm

.macro UNSTACK_SOFT
;these are the minimum to stack
movw 2, SP+, 0x3004
movw 2, SP+, 0x3002
movw 2, SP+, 0x3000
.endm
